



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android的四种加载模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android的四种加载模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 22:07:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在Android中每个界面都是一个Activity，切换界面操作其实是多个不同Activity之间的实例化操作。在Android中Activity的启动模式决定了Activity的启动运行方式。</p>
<p>　　Android总Activity的启动模式分为四种：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">Activity启动模式设置：

        &lt;activity android:name=".MainActivity" android:launchMode="standard" /&gt;

Activity的四种启动模式：

    . standard

        模式启动模式，每次激活Activity时都会创建Activity，并放入任务栈中。

    . singleTop

        如果在任务的栈顶正好存在该Activity的实例， 就重用该实例，否者就会创建新的实例并放入栈顶(即使栈中已经存在该Activity实例，只要不在栈顶，都会创建实例)。

    . singleTask

        如果在栈中已经有该Activity的实例，就重用该实例(会调用实例的onNewIntent())。重用时，会让该实例回到栈顶，因此在它上面的实例将会被移除栈。如果栈中不存在该实例，将会创建新的实例放入栈中。 

    . singleInstance

        在一个新栈中创建该Activity实例，并让多个应用共享改栈中的该Activity实例。一旦改模式的Activity的实例存在于某个栈中，任何应用再激活改Activity时都会重用该栈中的实例，其效果相当于多个应用程序共享一个应用，不管谁激活该Activity都会进入同一个应用中。</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　其中standard是系统默认的启动模式。</p>
<p>　　下面通过实例来演示standard的运行机制：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> private TextView text_show;<br />
     private Button btn_mode;

     @Override<br />
     public void onCreate(Bundle savedInstanceState) {<br />
         super.onCreate(savedInstanceState);<br />
         setContentView(R.layout.activity_main);

         text_show = (TextView) this.findViewById(R.id.text_show);

         text_show.setText(this.toString());

         btn_mode = (Button) this.findViewById(R.id.btn_mode);

     }

　　　　//按钮单击事件<br />
     public void LaunchStandard(View v){<br />
         startActivity(new Intent(this,MainActivity.class));

         text_show.setText(this.toString());<br />
     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　初始化界面如下：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082519471692.png" /></p>
<p>　　当点击按钮时，会创建新的Activity，通过TextView@后16进制数的显示即可看出，点击两次分别界面如下:</p>
<p>　　</p>
<p>　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082519483568.png" /> <img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082519484221.png" /></p>
<p>　　</p>
<p>　　此时，我们分析栈内部的运行机制：</p>
<p>　　　（依次从栈顶向上）</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082519525961.png" /></p>
<p>　　因此，这种Standard模式是每次都会创建新的Activity对象，当点击返回按钮时，他会将栈顶(当前Activity)消灭，然后跳到下一层，例如如果现在Activity是44ed8c50，那么当我们点击返回时Activity会变为44f28a48，不过此时在这个Activity中再次点击按钮创建对象时，它会另外创建新的Activity对象，这种模式可能大多数情况下不是我们需要的，因为对系统性能的消耗过大。</p>
<p>　　下面我们介绍两种能使用当前栈中Activity的启动模式：</p>
<p>　　2. singleTop</p>
<p>　　　　从上面的解释中即可知道，在每次使用新的Activity时会自动检测栈顶的当前Activity是否是需要引用的Activity，如果是则直接引用此Activity，而不会创建新的Activity。</p>
<p>　　　　我们在刚才的界面中加入一个"启动singletop模式"按钮，当点击时出现我们创建的singletop中，在Activity singletop中有一个按钮，启动singletop模式，表示启动当前Activity，由于我们在清单文件中配置Activity的启动模式为singleTop，因此此时不会再创建而是利用当前栈顶的singleTop Activity：</p>
<div>
<pre class="prettyprint linenums"> 　　　　&lt;activity<br />
            android:name=".SingleTopActivity"<br />
            android:label="@string/singletop"<br />
            android:launchMode="singleTop" &gt;<br />
        &lt;/activity&gt;</pre>
</div>
<p>　　　　界面初始化：</p>
<p>　　　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522001566.png" /></p>
<p>　　　　点击"启动singleTop模式"按钮：</p>
<p>　　　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522013733.png" /> 　　　</p>
<p>　　我们分析它的运行机制，可知，当程序运行到此时，栈中的数据形式为：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522002968.png" /></p>
<p>　　　　当我们在上面界面中点击"启动singleTop模式"按钮时，由于此Activity设置的启动模式为singleTop，因此它首先会检测当前栈顶是否为我们要请求的Activity对象，经验证成立，因此它不会创建新的Activity，而是引用当前栈顶的Activity。</p>
<p>　　　　　　 <img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522013733.png" /></p>
<p>　　　　虽然它不会创建新的Activity对象，不过它每次回调用onNewIntent()方法：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> @Override<br />
     protected void onNewIntent(Intent intent) {<br />
         // TODO Auto-generated method stub<br />
         super.onNewIntent(intent);

         Toast.makeText(this, new Date().toString(), 1).show();<br />
     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　　　我们为此方法编写代码输出当前日期，则在每次点击上面按钮时会输出当前日期。</p>
<p>　　3.singleTask</p>
<p>　　　　此启动模式和singleTop在名字上即可看出区别，即singleTop每次只检测当前栈顶的Activity是否是我们需要请求创建的，而singleTask则会检测栈中全部的Activity对象，从上向下，如果检测到是我们所请求的则会消灭此Activity对象上面的对象，直接把检测到的我们需要的Activity置为栈顶。</p>
<p>　　　　我们创建一个SingleTaskActivity，此界面中包含一个启动MainActivity和启动SingleTaskActivity按钮。</p>
<p>　　初始化:</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522360528.png" /></p>
<p>　　点击"启动singleTask模式"按钮：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522360956.png" /></p>
<p>　　在此界面中点击第二个按钮"启动singleTask模式"按钮，根据定义会检测当前栈中是否有此Activity对象，因此显示的还是当前的Activity，不会重新创建；</p>
<p>　　再点击"启动Standard模式"按钮，由于MainActivity的启动模式为standard，所以在此会重新创建一个MainActivity对象：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522361480.png" /></p>
<p>　　此时栈中数据格式为：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522413124.png" /></p>
<p>　　当在上面界面中点击"启动singleTask模式"按钮时，由于检测到当期栈中第二个为我们要创建的Activity，会将最上面的MainActivity消灭，然后将SingleTaskActivity设置为栈顶：</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/302664/2012082522362022.png" /></p>
<p>　　4.SingleInstance</p>
<p>　　　　此启动模式和我们使用的浏览器工作原理类似，我们都知道在多个程序中访问浏览器时，如果当前浏览器没有打开，则打开浏览器，否则会在当前打开的浏览器中访问。此模式会节省大量的系统资源，因为他能保证要请求的Activity对象在当前的栈中只存在一个。</p>
<p>　　　　</p>
<p>　　　　上面即为Android中的四种启动模式，我们在开发Android项目时会经常使用到，巧妙设置Activity的启动模式会节省系统开销和程序运行效率。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7oj518.html">初学ReactJS，写了一个RadioButtonList组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mxmx8.html">MVC 上传  下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpk4v9.html">转： 最值得阅读学习的 10 个 C 语言开源项目代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdejeoj9.html">c&num;中如何得到百分比数值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0dkweq.html">Spring ApplicationContextAware获取上下文</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1740e9.html">Java 十六进制转十进制</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xrjyr9.html">MVC Controller return 格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjlpw8.html">HTML5 获得canvas油漆环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dzkzq.html">VBS 读取文本文件特殊字符前如逗号的值并赋值给变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4j3z8.html">word采用尾注进行参考文献排版的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnle38.html">hashMap遍历方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7p369.html">Java的多线程实现生产&sol;消费模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/96px6v38.html">Analyzing &amp;&num;39&semi;enq&colon; HW - contention&amp;&num;39&semi; Wait Event &lpar;Doc ID 740075&period;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25xj1vq.html">oc之证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4p7meq.html">windows下的mysql迁移到linux下</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppopg79.html">MySql登陆密码忘记了 怎么办？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8km15m79.html">Vim：基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dmy048.html">windows下配置Groovy</a>
		</li>
						<li><a href="https://www.batexi.com/a/qloleoeq.html">【杂记】linux下各种软件安装方法（持续记录）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77lg6kq.html">Python 2&period;7&period;13安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zg4x39.html">【随手记-有空整理】使用PHPMailer和QQ邮箱实现邮件的自动发送</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1w4ejq.html">完全掌握KMP算法思想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjm5w38.html">WebService开发实例（Axis2实现，无需安装，快速实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge15ge8.html">python urllib和urllib2 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp0g20q.html">android -- 蓝牙 bluetooth （四）OPP文件传输</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjmgoj8.html">android -- 蓝牙 bluetooth （二） 打开蓝牙</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yogwz8.html">TCP之超时和重传</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zogxodq.html">深入理解GCD &lpar; 二 &rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7n738.html">POJ 1861 Network &lpar;模版kruskal算法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rl2v8.html">Linux下VNC的安装和开机启动</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
